Index: admin/js/_post.js
===================================================================
--- admin/js/_post.js	(revision 3880)
+++ admin/js/_post.js	(revision 0)
@@ -1,184 +1,231 @@
-/*global $, dotclear, datePicker, commentTb */
-'use strict';
+dotclear.commentExpander = function(line) {
+	var td = line.firstChild;
+	
+	var img = document.createElement('img');
+	img.src = dotclear.img_plus_src;
+	img.alt = dotclear.img_plus_alt;
+	img.className = 'expand';
+	$(img).css('cursor','pointer');
+	img.line = line;
+	img.onclick = function() { dotclear.viewCommentContent(this,this.line); };
+	
+	td.insertBefore(img,td.firstChild);
+};
 
-dotclear.viewCommentContent = function(line, action, e) {
-  action = action || 'toggle';
-  if ($(line).attr('id') == undefined) {
-    return;
-  }
-
-  const commentId = $(line).attr('id').substr(1);
-  const lineId = `ce${commentId}`;
-  let tr = document.getElementById(lineId);
-
-  // If meta key down or it's a spam then display content HTML code
-  const clean = (e.metaKey || $(line).hasClass('sts-junk'));
-
-  if (!tr) {
-    // Get comment content
-    dotclear.getCommentContent(commentId, function(content) {
-      if (content) {
-        // Content found
-        tr = document.createElement('tr');
-        tr.id = lineId;
-        const td = document.createElement('td');
-        td.colSpan = $(line).children('td').length;
-        td.className = 'expand';
-        tr.appendChild(td);
-        $(td).append(content);
-        $(line).addClass('expand');
-        line.parentNode.insertBefore(tr, line.nextSibling);
-      } else {
-        // No content, content not found or server error
-        $(line).removeClass('expand');
-      }
-    }, {
-      ip: false,
-      clean: clean
-    });
-  } else {
-    $(tr).toggle();
-    $(line).toggleClass('expand');
-  }
+dotclear.viewCommentContent = function(img,line) {
+	var commentId = line.id.substr(1);
+	
+	var tr = document.getElementById('ce'+commentId);
+	
+	if (!tr) {
+		tr = document.createElement('tr');
+		tr.id = 'ce'+commentId;
+		var td = document.createElement('td');
+		td.colSpan = 6;
+		td.className = 'expand';
+		tr.appendChild(td);
+		
+		img.src = dotclear.img_minus_src;
+		img.alt = dotclear.img_minus_alt;
+		
+		// Get comment content
+		$.get('services.php',{f:'getCommentById',id: commentId},function(data) {
+			var rsp = $(data).children('rsp')[0];
+			
+			if (rsp.attributes[0].value == 'ok') {
+				var comment = $(rsp).find('comment_display_content').text();
+				
+				if (comment) {
+					$(td).append(comment);
+					var comment_email = $(rsp).find('comment_email').text();
+					var comment_site = $(rsp).find('comment_site').text();
+					var comment_ip = $(rsp).find('comment_ip').text();
+					var comment_spam_disp = $(rsp).find('comment_spam_disp').text();
+					
+					$(td).append('<p><strong>' + dotclear.msg.website +
+					'</strong> ' + comment_site + '<br />' +
+					'<strong>' + dotclear.msg.email + '</strong> ' +
+					comment_email + '<br />' + comment_spam_disp + '</p>');
+				}
+			} else {
+				alert($(rsp).find('message').text());
+			}
+		});
+		
+		$(line).toggleClass('expand');
+		line.parentNode.insertBefore(tr,line.nextSibling);
+	}
+	else if (tr.style.display == 'none')
+	{
+		$(tr).toggle();
+		$(line).toggleClass('expand');
+		img.src = dotclear.img_minus_src;
+		img.alt = dotclear.img_minus_alt;
+	}
+	else
+	{
+		$(tr).toggle();
+		$(line).toggleClass('expand');
+		img.src = dotclear.img_plus_src;
+		img.alt = dotclear.img_plus_alt;
+	}
 };
 
 $(function() {
-  // Post preview
-  let $preview_url = $('#post-preview').attr('href');
-  if ($preview_url) {
-
-    // Make $preview_url absolute
-    let $a = document.createElement('a');
-    $a.href = $('#post-preview').attr('href');
-    $preview_url = $a.href;
-
-    // Check if admin and blog have same protocol (ie not mixed-content)
-    if (window.location.protocol == $preview_url.substring(0, window.location.protocol.length)) {
-      // Open preview in a modal iframe
-      $('#post-preview').magnificPopup({
-        type: 'iframe',
-        iframe: {
-          patterns: {
-            dotclear_preview: {
-              index: $preview_url,
-              src: $preview_url
-            }
-          }
-        }
-      });
-    } else {
-      // Open preview on antother window
-      $('#post-preview').click(function(e) {
-        e.preventDefault();
-        window.open($(this).attr('href'));
-      });
-    }
-  }
-
-  // Tabs events
-  $('#edit-entry').onetabload(function() {
-    dotclear.hideLockable();
-
-    // Add date picker
-    const post_dtPick = new datePicker($('#post_dt').get(0));
-    post_dtPick.img_top = '1.5em';
-    post_dtPick.draw();
-
-    // Confirm post deletion
-    $('input[name="delete"]').click(function() {
-      return window.confirm(dotclear.msg.confirm_delete_post);
-    });
-
-    // Hide some fields
-    $('#notes-area label').toggleWithLegend($('#notes-area').children().not('label'), {
-      user_pref: 'dcx_post_notes',
-      legend_click: true,
-      hide: $('#post_notes').val() == ''
-    });
-    $('#post_lang').parent().children('label').toggleWithLegend($('#post_lang'), {
-      user_pref: 'dcx_post_lang',
-      legend_click: true
-    });
-    $('#post_password').parent().children('label').toggleWithLegend($('#post_password'), {
-      user_pref: 'dcx_post_password',
-      legend_click: true,
-      hide: $('#post_password').val() == ''
-    });
-    $('#post_status').parent().children('label').toggleWithLegend($('#post_status'), {
-      user_pref: 'dcx_post_status',
-      legend_click: true
-    });
-    $('#post_dt').parent().children('label').toggleWithLegend($('#post_dt').parent().children().not('label'), {
-      user_pref: 'dcx_post_dt',
-      legend_click: true
-    });
-    $('#label_format').toggleWithLegend($('#label_format').parent().children().not('#label_format'), {
-      user_pref: 'dcx_post_format',
-      legend_click: true
-    });
-    $('#label_cat_id').toggleWithLegend($('#label_cat_id').parent().children().not('#label_cat_id'), {
-      user_pref: 'dcx_cat_id',
-      legend_click: true
-    });
-    $('#create_cat').toggleWithLegend($('#create_cat').parent().children().not('#create_cat'), {
-      // no cookie on new category as we don't use this every day
-      legend_click: true
-    });
-    $('#label_comment_tb').toggleWithLegend($('#label_comment_tb').parent().children().not('#label_comment_tb'), {
-      user_pref: 'dcx_comment_tb',
-      legend_click: true
-    });
-    $('#post_url').parent().children('label').toggleWithLegend($('#post_url').parent().children().not('label'), {
-      user_pref: 'post_url',
-      legend_click: true
-    });
-    // We load toolbar on excerpt only when it's ready
-    $('#excerpt-area label').toggleWithLegend($('#excerpt-area').children().not('label'), {
-      user_pref: 'dcx_post_excerpt',
-      legend_click: true,
-      hide: $('#post_excerpt').val() == ''
-    });
-
-    // Replace attachment remove links by a POST form submit
-    $('a.attachment-remove').click(function() {
-      this.href = '';
-      const m_name = $(this).parents('ul').find('li:first>a').attr('title');
-      if (window.confirm(dotclear.msg.confirm_remove_attachment.replace('%s', m_name))) {
-        var f = $('#attachment-remove-hide').get(0);
-        f.elements.media_id.value = this.id.substring(11);
-        f.submit();
-      }
-      return false;
-    });
-  });
-
-  $('#comments').onetabload(function() {
-    $.expandContent({
-      line: $('#form-comments .comments-list tr:not(.line)'),
-      lines: $('#form-comments .comments-list tr.line'),
-      callback: dotclear.viewCommentContent
-    });
-    $('#form-comments .checkboxes-helpers').each(function() {
-      dotclear.checkboxesHelpers(this);
-    });
-
-    dotclear.commentsActionsHelper();
-  });
-
-  $('#trackbacks').onetabload(function() {
-    $.expandContent({
-      line: $('#form-trackbacks .comments-list tr:not(.line)'),
-      lines: $('#form-trackbacks .comments-list tr.line'),
-      callback: dotclear.viewCommentContent
-    });
-    $('#form-trackbacks .checkboxes-helpers').each(function() {
-      dotclear.checkboxesHelpers(this);
-    });
-
-    dotclear.commentsActionsHelper();
-  });
-
-  $('#add-comment').onetabload(function() {
-    commentTb.draw('xhtml');
-  });
+	if (!document.getElementById) { return; }
+	
+	if (document.getElementById('edit-entry'))
+	{
+		// Get document format and prepare toolbars
+		var formatField = $('#post_format').get(0);
+		$(formatField).change(function() {
+			excerptTb.switchMode(this.value);
+			contentTb.switchMode(this.value);
+		});
+		
+		var excerptTb = new jsToolBar(document.getElementById('post_excerpt'));
+		var contentTb = new jsToolBar(document.getElementById('post_content'));
+		excerptTb.context = contentTb.context = 'post';
+	}
+	
+	if (document.getElementById('comment_content')) {
+		var commentTb = new jsToolBar(document.getElementById('comment_content'));
+	}
+	
+	// Post preview
+	$('#post-preview').modalWeb($(window).width()-40,$(window).height()-40);
+	
+	// Tabs events
+	$('#edit-entry').onetabload(function() {
+		dotclear.hideLockable();
+		
+		// Add date picker
+		var post_dtPick = new datePicker($('#post_dt').get(0));
+		post_dtPick.img_top = '1.5em';
+		post_dtPick.draw();
+		
+		// Confirm post deletion
+		$('input[name="delete"]').click(function() {
+				return window.confirm(dotclear.msg.confirm_delete_post);
+		});
+		
+		// Hide some fields
+		$('#notes-area label').toggleWithLegend($('#notes-area').children().not('label'),{
+			cookie: 'dcx_post_notes',
+			hide: $('#post_notes').val() == ''
+		});
+		$('#post_lang').parent().toggleWithLegend($('#post_lang'),{
+			cookie: 'dcx_post_lang'
+		});
+		$('#post_password').parent().toggleWithLegend($('#post_password'),{
+			cookie: 'dcx_post_password',
+			hide: $('#post_password').val() == ''
+		});
+		
+		// We load toolbar on excerpt only when it's ready
+		$('#excerpt-area label').toggleWithLegend($('#excerpt-area').children().not('label'),{
+			fn: function() { excerptTb.switchMode(formatField.value); },
+			cookie: 'dcx_post_excerpt',
+			hide: $('#post_excerpt').val() == ''
+		});
+		
+		// Load toolbars
+		contentTb.switchMode(formatField.value);
+		
+		// Replace attachment remove links by a POST form submit
+		$('a.attachment-remove').click(function() {
+			this.href = '';
+			var m_name = $(this).parents('ul').find('li:first>a').attr('title');
+			if (window.confirm(dotclear.msg.confirm_remove_attachment.replace('%s',m_name))) {
+				var f = $('#attachment-remove-hide').get(0);
+				f.elements['media_id'].value = this.id.substring(11);
+				f.submit();
+			}
+			return false;
+		});
+		
+		// Markup validator
+		var h = document.createElement('h4');
+		var a = document.createElement('a');
+		a.href = '#';
+		$(a).click(function() {
+			var params = {
+				xd_check: dotclear.nonce,
+				f: 'validatePostMarkup',
+				excerpt: $('#post_excerpt').text(),
+				content: $('#post_content').text(),
+				format: $('#post_format').get(0).value,
+				lang: $('#post_lang').get(0).value
+			};
+			
+			$.post('services.php',params,function(data) {
+				if ($(data).find('rsp').attr('status') != 'ok') {
+					alert($(data).find('rsp message').text());
+					return false;
+				}
+				
+				if ($(data).find('valid').text() == 1) {
+					var p = document.createElement('p');
+					p.id = 'markup-validator';
+					
+					if ($('#markup-validator').length > 0) {
+						$('#markup-validator').remove();
+					}
+					
+					$(p).addClass('message');
+					$(p).text(dotclear.msg.xhtml_valid);
+					$(p).insertAfter(h);
+					$(p).backgroundFade({sColor:'#666666',eColor:'#ffcc00',steps:50},function() {
+							$(this).backgroundFade({sColor:'#ffcc00',eColor:'#666666'});
+					});
+				} else {
+					var div = document.createElement('div');
+					div.id = 'markup-validator';
+					
+					if ($('#markup-validator').length > 0) {
+						$('#markup-validator').remove();
+					}
+					
+					$(div).addClass('error');
+					$(div).html('<p><strong>' + dotclear.msg.xhtml_not_valid + '</strong></p>' + $(data).find('errors').text());
+					$(div).insertAfter(h);
+					$(div).backgroundFade({sColor:'#ffffff',eColor:'#ff9999',steps:50},function() {
+							$(this).backgroundFade({sColor:'#ff9999',eColor:'#ffffff'});
+					});
+				}
+				
+				return false;
+			});
+			
+			return false;
+		});
+		
+		a.appendChild(document.createTextNode(dotclear.msg.xhtml_validator));
+		h.appendChild(a);
+		$(h).appendTo('#entry-content');
+		
+		// Check unsaved changes before XHTML conversion
+		var excerpt = $('#post_excerpt').val();
+		var content = $('#post_content').val();
+		$('#convert-xhtml').click(function() {
+			if (excerpt != $('#post_excerpt').val() || content != $('#post_content').val()) {
+				return window.confirm(dotclear.msg.confirm_change_post_format);
+			}	
+		});
+	});
+	
+	$('#comments').onetabload(function() {
+		$('.comments-list tr.line').each(function() {
+			dotclear.commentExpander(this);
+		});
+		$('.checkboxes-helpers').each(function() {
+			dotclear.checkboxesHelpers(this);
+		});
+		
+		dotclear.commentsActionsHelper();
+	});
+	
+	$('#add-comment').onetabload(function() {
+		commentTb.draw('xhtml');
+	});
 });
Index: admin/js/_posts_list.js
===================================================================
--- admin/js/_posts_list.js	(revision 4007)
+++ admin/js/_posts_list.js	(revision 0)
@@ -1,58 +1,79 @@
-/*global $, dotclear */
-'use strict';
+dotclear.postExpander = function(line) {
+	var td = line.firstChild;
+	
+	var img = document.createElement('img');
+	img.src = dotclear.img_plus_src;
+	img.alt = dotclear.img_plus_alt;
+	img.className = 'expand';
+	$(img).css('cursor','pointer');
+	img.line = line;
+	img.onclick = function() { dotclear.viewPostContent(this,this.line); };
+	
+	td.insertBefore(img,td.firstChild);
+};
 
-dotclear.viewPostContent = function(line, action, e) {
-  action = action || 'toggle';
-  if ($(line).attr('id') == undefined) {
-    return;
-  }
-
-  const postId = $(line).attr('id').substr(1);
-  const lineId = `pe${postId}`;
-  let tr = document.getElementById(lineId);
-
-  if (!tr) {
-    // Get post content if possible
-    dotclear.getEntryContent(postId, function(content) {
-      if (content) {
-        // Content found
-        tr = document.createElement('tr');
-        tr.id = lineId;
-        const td = document.createElement('td');
-        td.colSpan = $(line).children('td').length;
-        td.className = 'expand';
-        tr.appendChild(td);
-        $(td).append(content);
-        $(line).addClass('expand');
-        line.parentNode.insertBefore(tr, line.nextSibling);
-      } else {
-        $(line).toggleClass('expand');
-      }
-    }, {
-      clean: (e.metaKey)
-    });
-  } else {
-    $(tr).toggle();
-    $(line).toggleClass('expand');
-  }
+dotclear.viewPostContent = function(img,line) {
+	var postId = line.id.substr(1);
+	var tr = document.getElementById('pe'+postId);
+	
+	if (!tr) {
+		tr = document.createElement('tr');
+		tr.id = 'pe'+postId;
+		var td = document.createElement('td');
+		td.colSpan = 8;
+		td.className = 'expand';
+		tr.appendChild(td);
+		
+		img.src = dotclear.img_minus_src;
+		img.alt = dotclear.img_minus_alt;
+		
+		// Get post content
+		$.get('services.php',{f:'getPostById', id: postId, post_type: ''},function(data) {
+			var rsp = $(data).children('rsp')[0];
+			
+			if (rsp.attributes[0].value == 'ok') {
+				var post = $(rsp).find('post_display_content').text();
+				var post_excerpt = $(rsp).find('post_display_excerpt').text();
+				var res = '';
+				
+				if (post) {
+					if (post_excerpt) {
+						res += post_excerpt + '<hr />';
+					}
+					res += post;
+					$(td).append(res);
+				}
+			} else {
+				alert($(rsp).find('message').text());
+			}
+		});
+		
+		$(line).toggleClass('expand');
+		line.parentNode.insertBefore(tr,line.nextSibling);
+	}
+	else if (tr.style.display == 'none')
+	{
+		$(tr).toggle();
+		$(line).toggleClass('expand');
+		img.src = dotclear.img_minus_src;
+		img.alt = dotclear.img_minus_alt;
+	}
+	else
+	{
+		$(tr).toggle();
+		$(line).toggleClass('expand');
+		img.src = dotclear.img_plus_src;
+		img.alt = dotclear.img_plus_alt;
+	}
 };
 
 $(function() {
-  // Entry type switcher
-  $('#type').change(function() {
-    this.form.submit();
-  });
-
-  $.expandContent({
-    line: $('#form-entries tr:not(.line)'),
-    lines: $('#form-entries tr.line'),
-    callback: dotclear.viewPostContent
-  });
-  $('.checkboxes-helpers').each(function() {
-    dotclear.checkboxesHelpers(this, undefined, '#form-entries td input[type=checkbox]', '#form-entries #do-action');
-  });
-  $('#form-entries td input[type=checkbox]').enableShiftClick();
-  dotclear.condSubmit('#form-entries td input[type=checkbox]', '#form-entries #do-action');
-  dotclear.postsActionsHelper();
-  dotclear.responsiveCellHeaders(document.querySelector('#form-entries table'), '#form-entries table', 1);
+	$('#form-entries tr.line').each(function() {
+		dotclear.postExpander(this);
+	});
+	$('.checkboxes-helpers').each(function() {
+		dotclear.checkboxesHelpers(this);
+	});
+	$('#form-entries td input[type=checkbox]').enableShiftClick();
+	dotclear.postsActionsHelper();
 });
Index: admin/js/_preferences.js
===================================================================
--- admin/js/_preferences.js	(revision 3981)
+++ admin/js/_preferences.js	(revision 0)
@@ -1,27 +1,22 @@
-/*global $, getData */
-'use strict';
-
 $(function() {
-  if ($('#new_pwd').length == 0) {
-    return;
-  }
-  const texts = getData('preferences');
-  $('#new_pwd').pwstrength({
-    texts: texts
-  });
-  const user_email = $('#user_email').val();
-  $('#user-form').submit(function() {
-    var e = this.elements.cur_pwd;
-    if (e.value != '') {
-      return true;
-    }
-    if ($('#user_email').val() != user_email || $('#new_pwd').val() != '') {
-      $(e).addClass('missing').focusout(function() {
-        $(this).removeClass('missing');
-      });
-      e.focus();
-      return false;
-    }
-    return true;
-  });
+	if ($('#new_pwd').length == 0) {
+		return;
+	}
+	
+	var user_email = $('#user_email').val();
+	
+	$('#user-form').submit(function() {
+		var e = this.elements['cur_pwd'];
+		if (e.value != '') {
+			return true;
+		}
+		if ($('#user_email').val() != user_email || $('#new_pwd').val() != '') {
+			e.focus();
+			$(e).backgroundFade({sColor:'#ffffff',eColor:'#ff9999',steps:50},function() {
+				$(this).backgroundFade({sColor:'#ff9999',eColor:'#ffffff'});
+			});
+			return false;
+		}
+		return true;
+	});
 });
Index: admin/js/_trackbacks.js
===================================================================
--- admin/js/_trackbacks.js	(revision 3706)
+++ admin/js/_trackbacks.js	(revision 0)
@@ -1,10 +1,7 @@
-/*global $ */
-'use strict';
-
 $(function() {
-  $('#tb_excerpt').keypress(function() {
-    if (this.value.length > 255) {
-      this.value = this.value.substring(0, 255);
-    }
-  });
+	$('#tb_excerpt').keypress(function() {
+		if (this.value.length > 255) {
+			this.value = this.value.substring(0,255);
+		}
+	});
 });
Index: admin/js/_users.js
===================================================================
--- admin/js/_users.js	(revision 4007)
+++ admin/js/_users.js	(revision 0)
@@ -1,53 +1,46 @@
-/*global $, dotclear */
-'use strict';
-
 $(function() {
-  $('.checkboxes-helpers').each(function() {
-    dotclear.checkboxesHelpers(this, undefined, '#form-users input[type="checkbox"]', '#form-users #do-action');
-  });
-  dotclear.condSubmit('#form-users input[type="checkbox"]', '#form-users #do-action');
-  dotclear.responsiveCellHeaders(document.querySelector('#form-users table'), '#form-users table', 1);
-  $('#form-users').submit(function() {
-    const action = $(this).find('select[name="action"]').val();
-    let user_ids = [];
-    let nb_posts = [];
-    let i;
-    let msg_cannot_delete = false;
-
-    $(this).find('input[name="users[]"]').each(function() {
-      user_ids.push(this);
-    });
-    $(this).find('input[name="nb_post[]"]').each(function() {
-      nb_posts.push(this.value);
-    });
-
-    if (action == 'deleteuser') {
-      for (i = 0; i < user_ids.length; i++) {
-        if (nb_posts[i] > 0) {
-          if (user_ids[i].checked == true) {
-            msg_cannot_delete = true;
-            user_ids[i].checked = false;
-          }
-        }
-      }
-      if (msg_cannot_delete == true) {
-        window.alert(dotclear.msg.cannot_delete_users);
-      }
-    }
-
-    let selectfields = 0;
-    for (i = 0; i < user_ids.length; i++) {
-      selectfields += user_ids[i].checked;
-    }
-
-    if (selectfields == 0) {
-      return false;
-    }
-
-    if (action == 'deleteuser') {
-      return window.confirm(dotclear.msg.confirm_delete_user.replace('%s', $('input[name="users[]"]:checked').size()));
-    }
-
-    return true;
-  });
+	$('.checkboxes-helpers').each(function() {
+		dotclear.checkboxesHelpers(this);
+	});
+	$('#form-users').submit(function() {
+		var action = $(this).find('select[name="dispatch_action"]').val();
+		var user_ids = new Array();
+		var nb_posts = new Array();
+		var i;
+		var msg_cannot_delete = false;
+		
+		$(this).find('input[name="user_id[]"]').each(function() {
+			user_ids.push(this);
+		});
+		$(this).find('input[name="nb_post[]"]').each(function() {
+			nb_posts.push(this.value);
+		});
+		
+		if (action == 'deleteuser') {
+			for (i=0; i<user_ids.length; i++) {
+				if (nb_posts[i] > 0) {
+					user_ids[i].checked = false;
+					msg_cannot_delete = true;
+				}
+			}
+			if (msg_cannot_delete == true) {
+				alert(dotclear.msg.cannot_delete_users);
+			}
+		}
+		
+		var selectfields = 0;
+		for (i=0; i<user_ids.length; i++) {
+			selectfields += user_ids[i].checked;
+		}
+		
+		if (selectfields == 0) {
+			return false;
+		}
+		
+		if (action == 'deleteuser') {
+			return window.confirm(dotclear.msg.confirm_delete_user.replace('%s',$('input[name="user_id[]"]:checked').size()));
+		}
+		
+		return true;
+	});
 });
Index: admin/js/color-picker.js
===================================================================
--- admin/js/color-picker.js	(revision 3880)
+++ admin/js/color-picker.js	(revision 0)
@@ -1,87 +1,79 @@
-/*global $, jQuery */
-'use strict';
-
 $(function() {
-  $('.colorpicker').colorPicker();
+	$('.colorpicker').colorPicker();
 });
 
 jQuery.fn.colorPicker = function() {
-  $(this).each(function() {
-    let colbox = $('#jquery-colorpicker')[0];
-    if (colbox == undefined) {
-      colbox = document.createElement('div');
-      colbox.id = 'jquery-colorpicker';
-      colbox.linkedto = null;
-
-      $(colbox).addClass('color-color-picker');
-      $(colbox).css({
-        display: 'none',
-        position: 'absolute'
-      });
-      $('body').append(colbox);
-    }
-    const f = $.farbtastic(colbox);
-    f.linkTo(this);
-
-    const handler = $(document.createElement('img'));
-    handler.attr('src', 'images/picker.png');
-    handler.attr('alt', '');
-
-    const span = $(document.createElement('span'));
-
-    if ($(this).css('position') == 'absolute') {
-      span.css('position', 'absolute');
-      span.css('top', $(this).css('top'));
-      span.css('left', $(this).css('left'));
-      $(this).css('position', 'static');
-    } else {
-      span.css('position', 'relative');
-    }
-    span.css('display', 'inline-block');
-    span.css('padding', '0 5px 0 0');
-    $(this).wrap(span);
-    $(this).after(handler);
-
-    handler.css({
-      position: 'absolute',
-      top: 3,
-    });
-
-    handler.css({
-      cursor: 'default'
-    });
-
-    const This = this;
-    handler.click(function() {
-      if ($(colbox).css('display') == 'none' || this != colbox.linkedto) {
-        f.linkTo(This);
-        This.focus();
-        const offset = $(This).offset();
-        $(colbox).css({
-          zIndex: 1000,
-          top: offset.top + $(this).height() + 5,
-          left: offset.left
-        });
-        if (document.all) {
-          $('select').hide();
-        }
-        $(colbox).show();
-        colbox.linkedto = this;
-
-      } else {
-        $(colbox).hide();
-        if (document.all) {
-          $('select').show();
-        }
-        colbox.linkedto = null;
-      }
-    });
-    $(this).blur(function() {
-      $(colbox).hide();
-      if (document.all) {
-        $('select').show();
-      }
-    });
-  });
-  return this;
+	$(this).each(function() {
+		var colbox, f;
+		var colbox = $('#jquery-colorpicker')[0];
+		
+		if (colbox == undefined) {
+			colbox = document.createElement('div');
+			colbox.id = 'jquery-colorpicker';
+			colbox.linkedto = null;
+			
+			$(colbox).css({border: '1px solid #000', width: '195px', background: '#fff', position: 'absolute'});
+			$(colbox).css({display: 'none'});
+			$('body').append(colbox);
+		}
+		f = $.farbtastic(colbox);
+		f.linkTo(this);
+		
+		var handler = $(document.createElement('img'));
+		handler.attr('src','images/picker.png');
+		handler.attr('alt','');
+		
+		var span = $(document.createElement('span'));
+		
+		if ($(this).css('position') == 'absolute') {
+			span.css('position','absolute');
+			span.css('top',$(this).css('top'));
+			span.css('left',$(this).css('left'));
+			$(this).css('position','static');
+		} else {
+			span.css('position','relative');
+		}
+		span.css('display','block');
+		
+		span.css('width',($(this).width()+12)+'px');
+		span.css('padding','0 5px 0 0');
+		$(this).wrap(span);
+		$(this).after(handler);
+		
+		var offset = $(this).offset();
+		handler.css({
+			position: 'absolute',
+			top: 3,
+			right: 0
+		});
+		
+		handler.css({cursor: 'default'});
+		
+		var This = this;
+		handler.click(function() {
+			if ($(colbox).css('display') == 'none' || this != colbox.linkedto) {
+				f.linkTo(This);
+				This.focus();
+				var offset = $(This).offset();
+				$(colbox).css({
+					zIndex: 1000,
+					top: offset.top + $(this).height() + 5,
+					left: offset.left
+				});
+				if (document.all) { $('select').hide(); }
+				$(colbox).show();
+				colbox.linkedto = this;
+				
+			} else {
+				$(colbox).hide();
+				if (document.all) { $('select').show(); }
+				colbox.linkedto = null;
+			}
+		});
+		$(this).blur(function() {
+			$(colbox).hide();
+			if (document.all) { $('select').show(); }
+		});
+	});
+	return this;
 };
